###############################################################################

stages:
  - build
  - test
  - publish

###############################################################################

variables:
  HUGO_BUILD_FOLDER: "public"

###############################################################################

before_script:
  - test -n "${HUGO_BUILD_FOLDER}"

###############################################################################

build:
  stage: build
  image:
    name: registry.gitlab.com/bitservices/containers/hugo:0.125.4-r3
    entrypoint: [ "" ]
  variables:
    GIT_SUBMODULE_STRATEGY: normal
  script:
    - echo "-- Beginning Build --"
    - hash hugo
    - echo "-- Building Website --"
    - echo "Build Folder - ${HUGO_BUILD_FOLDER}"
    - hugo --verbose --destination "${HUGO_BUILD_FOLDER}"
  artifacts:
    paths:
      - "${HUGO_BUILD_FOLDER}"
    expire_in: 1 week

###############################################################################

test:
  stage: test
  image:
    name: registry.gitlab.com/bitservices/containers/html-proofer:5.0.9
    entrypoint: [ "" ]
  variables:
    GIT_STRATEGY: none
    HTML_PROOFER_OPTS: --directory-index-file "index.html"
    HTML_PROOFER_BINARY: htmlproofer
  script:
    - echo "-- Beginning Test --"
    - hash "${HTML_PROOFER_BINARY}"
    - test -d "${HUGO_BUILD_FOLDER}"
    - echo "-- Running HTML Proofer --"
    - if [ -n "${HTML_PROOFER_OPTS}" ]; then
    -   HTML_PROOFER_COMMAND="${HTML_PROOFER_BINARY} \"${HUGO_BUILD_FOLDER}\" ${HTML_PROOFER_OPTS}"
    - else
    -   HTML_PROOFER_COMMAND="${HTML_PROOFER_BINARY} \"${HUGO_BUILD_FOLDER}\""
    - fi
    - eval "${HTML_PROOFER_COMMAND}"

###############################################################################

publish:
  stage: publish
  image:
    name: amazon/aws-cli:2.17.22
    entrypoint: [ "" ]
  rules:
    - if: $CI_COMMIT_TAG
  variables:
    GIT_STRATEGY: none
  script:
    - echo "-- Beginning Deploy --"
    - test -n "${AWS_ACCESS_KEY_ID}"
    - test -n "${AWS_SECRET_ACCESS_KEY}"
    - test -n "${AWS_S3_BUCKET}"
    - test -d "${HUGO_BUILD_FOLDER}"
    - hash aws
    - echo "-- Begin S3 Sync --"
    - aws s3 sync "${HUGO_BUILD_FOLDER}" "s3://${AWS_S3_BUCKET}/" --delete --quiet
    - echo "-- Begin Invalidate CloudFront Cache --"
    - CLOUDFRONT_DISTRUBUTION="$(aws cloudfront list-distributions --query "DistributionList.Items[*].{id:Id,origins:Origins.Items[*].DomainName}[?contains(origins, '${AWS_S3_BUCKET}.s3.amazonaws.com')].id" --output text)"
    - test -n "${CLOUDFRONT_DISTRUBUTION}"
    - aws cloudfront create-invalidation --distribution-id "${CLOUDFRONT_DISTRUBUTION}" --paths "/*" --query 'Invalidation.Id' --output text

###############################################################################
